> ## Documentation Index
> Fetch the complete documentation index at: https://conductorone-docs-mcp-bridge-private-server.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create App Access Requests Defaults

> Create or replace the access request default settings for an app.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples post /api/v1/apps/{app_id}/access_request_defaults
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/apps/{app_id}/access_request_defaults:
    post:
      tags:
        - AppAccessRequestDefaults
      summary: Create App Access Requests Defaults
      description: Create or replace the access request default settings for an app.
      operationId: >-
        c1.api.app.v1.AppAccessRequestsDefaultsService.CreateAppAccessRequestsDefaults
      parameters:
        - in: path
          name: app_id
          required: true
          schema:
            description: The app id for the app access request rule
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/c1.api.app.v1.AppAccessRequestDefaultsInput'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/c1.api.app.v1.AppAccessRequestDefaults'
          description: Successful response
      x-codeSamples:
        - lang: go
          label: CreateAppAccessRequestsDefaults
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.AppAccessRequestsDefaults.CreateAppAccessRequestsDefaults(ctx, operations.C1APIAppV1AppAccessRequestsDefaultsServiceCreateAppAccessRequestsDefaultsRequest{\n        AppID: \"<id>\",\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.AppAccessRequestDefaults != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.appAccessRequestsDefaults.createAppAccessRequestsDefaults({
                appId: "<id>",
              });

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.app.v1.AppAccessRequestDefaultsInput:
      description: >
        The AppAccessRequestDefaults message.


        This message contains a oneof named max_grant_duration. Only a single
        field of the following list may be set at a time:
          - durationUnset
          - durationGrant
      properties:
        catalogIds:
          description: The request catalog ids for the app access request rule.
          items:
            type: string
          type:
            - array
            - 'null'
        defaultsEnabled:
          description: >-
            If true the app level request configuration will be applied to
            specified resource types.
          type:
            - boolean
            - 'null'
        durationGrant:
          format: duration
          type:
            - string
            - 'null'
        durationUnset:
          type:
            - object
            - 'null'
        emergencyGrantEnabled:
          description: If emergency grants are enabled for this app access request rule.
          type:
            - boolean
            - 'null'
        emergencyGrantPolicyId:
          description: The policy id for the emergency grant policy.
          type:
            - string
            - 'null'
        requestPolicyId:
          description: >-
            The ID of the request policy to apply to entitlements matching this
            rule.
          type:
            - string
            - 'null'
        requestSchemaId:
          description: >-
            The ID of the request schema to apply to entitlements matching this
            rule.
          type:
            - string
            - 'null'
        resourceTypeIds:
          description: >-
            The app resource type ids for which the app access request defaults
            are applied.
          items:
            type: string
          type:
            - array
            - 'null'
        state:
          description: The last applied state of the app access request defaults.
          enum:
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_UNSPECIFIED
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_RUNNING
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_SUCCESS
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_FAILED
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCELING
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCEL_SUCCESS
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCEL_ERROR
          type:
            - string
            - 'null'
          x-speakeasy-unknown-values: allow
      title: App Access Request Defaults
      type: object
      x-speakeasy-name-override: AppAccessRequestDefaults
    c1.api.app.v1.AppAccessRequestDefaults:
      description: >
        The AppAccessRequestDefaults message.


        This message contains a oneof named max_grant_duration. Only a single
        field of the following list may be set at a time:
          - durationUnset
          - durationGrant
      properties:
        appId:
          description: The app id for the app access request rule
          type:
            - string
            - 'null'
        catalogIds:
          description: The request catalog ids for the app access request rule.
          items:
            type: string
          type:
            - array
            - 'null'
        defaultsEnabled:
          description: >-
            If true the app level request configuration will be applied to
            specified resource types.
          type:
            - boolean
            - 'null'
        durationGrant:
          format: duration
          type:
            - string
            - 'null'
        durationUnset:
          type:
            - object
            - 'null'
        emergencyGrantEnabled:
          description: If emergency grants are enabled for this app access request rule.
          type:
            - boolean
            - 'null'
        emergencyGrantPolicyId:
          description: The policy id for the emergency grant policy.
          type:
            - string
            - 'null'
        requestPolicyId:
          description: >-
            The ID of the request policy to apply to entitlements matching this
            rule.
          type:
            - string
            - 'null'
        requestSchemaId:
          description: >-
            The ID of the request schema to apply to entitlements matching this
            rule.
          type:
            - string
            - 'null'
        resourceTypeIds:
          description: >-
            The app resource type ids for which the app access request defaults
            are applied.
          items:
            type: string
          type:
            - array
            - 'null'
        state:
          description: The last applied state of the app access request defaults.
          enum:
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_UNSPECIFIED
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_RUNNING
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_SUCCESS
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_FAILED
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCELING
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCEL_SUCCESS
            - APP_ACCESS_REQUEST_DEFAULTS_LAST_APPLY_STATE_CANCEL_ERROR
          type:
            - string
            - 'null'
          x-speakeasy-unknown-values: allow
      title: App Access Request Defaults
      type: object
      x-speakeasy-name-override: AppAccessRequestDefaults
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````